<template>
  <!-- ForgotPassword Form -->
  <form id="forgot-password-form" class="w-full">

    <!-- Error messages -->
    <t-alert v-if="form.globalError" variant="error" class="mb-8" show>
      <p class="text-error">{{ form.globalError }}</p>
    </t-alert>

    <!-- Email -->
    <Input
      v-model="emailValue"
      name="email"
      :variant="emailState ? 'primary' : 'error'"
      :state="emailState"
      :label="$h.capitalize($t('user.email'))"
      :placeholder="$h.capitalize($t('user.email'))"
      :error="getFieldErrorMessage('email')"
      fluid
      class="mb-4"
    />

    <!-- Confirm button -->
    <Button
      variant="action"
      :disabled="!isFormValid"
      @click.native="handleOk"
      fluid
    >
      {{ $t('global.confirm') | capitalize }}
    </Button>

  </form>
</template>

<script>
// vuex helpers
import { mapActions } from 'vuex'
// BaseForm
import BaseForm from '@/components/commons/form/BaseForm'
// utils
import { validateEmail } from '#utils'

/**
 * ForgotPasswordForm component
 */
export default {
  name: 'ForgotPasswordForm',
  extends: BaseForm,
  // 'form' option (see src/components/commons/form/BaseForm)
  form: {
    fields: {
      /**
       * email
       */
      email: {
        // Default: generate 'emailValue' & 'emailChanged'
        default: function () {
          return ''
        },
        // Generate: 'emailState'
        state: function () {
          return !this.isFieldInError('email') // No errors ?
            ? this.emailValue.length > 0 // Filled ?
              ? this.isEmailValid // Valid ?
              : true
            : false // else -> errors
        },
        // Generate: 'isEmailValid'
        isValid: function () {
          return validateEmail(this.emailValue)
        }
      }
    }
  },
  methods: {
    // Map actions from 'Users' store module
    ...mapActions('Users', [
      'forgotPassword'
    ]),
    /**
     * Handle click on 'confirm' submit button.
     *
     * @param {Object} evt - The event payload
     * @returns {void}
     */
    async handleOk (evt) {
      // Prevent click
      evt.preventDefault()
      // Reset errors before
      this.resetErrors()
      // Wait for forgotPassword function
      const forgotPasswordResponse = await this.forgotPassword({
        email: this.emailValue
      })
      // If passed
      if (!(forgotPasswordResponse instanceof Error)) {
        // Emit 'email-sent' event
        this.$emit('email-sent')
      // Else parse server error
      } else {
        this.setFormErrors(forgotPasswordResponse) // Set form errors from response
      }
    }
  }
}
</script>
